#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <npapi.h>


#define NUMIF	4


int fragsend(struct fbuffer *fb);


void fail(char *s)
{
  fprintf(stderr, "%s\n", s);
  exit(-1);
}


void shandle(int sig)
{ 
  fprintf(stderr, "Exiting...\n");
  exit(0);
}


int main(int argc, char *argv[])
{ 
char buffer[2048];
struct fbuffer *f = (struct fbuffer *)buffer;
int i, rv;

  signal(SIGINT, shandle);
  signal(SIGTERM, shandle);

  if ( np_start(0, 0) < 0 )
    fail("Couldn't connect to network processor.");


  while ( 1 )
  {
    next_frame(f);

    if ( f->ifnum == 0 )
      f->ofnum = 3;
    else if ( f->ifnum == 3 )
      f->ofnum = 0;
    else
    {
      fprintf(stderr,"Don't know where to send frame from if %d\n",f->ifnum);
      fail("quitting\n");
    }

    if ( fragsend(f) < 0 )
      fail("Error sending frame on!\n");
  }


  if ( rv < 0 )
    fail("Error getting next frame!");

  np_stop();

  return 0;
}
